//+------------------------------------------------------------------+
//|                                                    MQL5 Note.mq5 |
//|                           Copyright 08 May 2012 , onewithzachy   |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright 08 May 2012 , onewithzachy"
#property link      ""
#property version   "1.00"
#property description "IA 8 Paires for phenix"
#property description "written by onewithzachy on MT5 build 642"
#property description "http://www.mql5.com/en/forum/6666"
#property link "http://www.mql5.com/en/forum/6666"

#property script_show_inputs

#include <Trade\Trade.mqh>

input double Lot          = 0.1;
input double SL           = 300;
input double TP           = 300;
input string TradeComment = "IA 8 Paires";

double My_SL = 0.0, My_TP = 0.0;
int TradesSent = 0;
//+------------------------------------------------------------------+
//| Script program start function                                    |
//+------------------------------------------------------------------+

void OnStart()
  {
  PlaySound("wait.wav");
//---
  ORDER_SEND_FUNC ("AUDUSD", ORDER_TYPE_SELL);
  ORDER_SEND_FUNC ("EURUSD", ORDER_TYPE_SELL);
  ORDER_SEND_FUNC ("GBPUSD", ORDER_TYPE_SELL);
  ORDER_SEND_FUNC ("NZDUSD", ORDER_TYPE_SELL);
  ORDER_SEND_FUNC ("NZDJPY", ORDER_TYPE_BUY);
  ORDER_SEND_FUNC ("EURJPY", ORDER_TYPE_BUY);
  ORDER_SEND_FUNC ("AUDJPY", ORDER_TYPE_BUY);
  ORDER_SEND_FUNC ("GBPJPY", ORDER_TYPE_BUY);
//---
  PlaySound("wait.wav");
  }
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
ulong ORDER_SEND_FUNC (string my_symbol, ENUM_ORDER_TYPE  my_trade_type)
   { 
   int    try         = 0;
   ulong  ticket      = 0.0;
   ulong  deal        = 0.0;
   uint   return_code = 0;
   double my_price    = 0.0;
   
   My_SL = SL; My_TP = TP;
   
   switch (my_trade_type)
     {
     case  ORDER_TYPE_BUY :
       {
       my_price = SymbolInfoDouble(my_symbol,SYMBOL_ASK);
       My_SL = -1*My_SL;
       break;
       }
           
     case  ORDER_TYPE_SELL :
       {
       my_price = SymbolInfoDouble(my_symbol,SYMBOL_BID);
       My_TP = -1*My_TP;
       break;
       }
     }
     
   //--- Order send operation
   while (true)
      {
      try ++;
      ResetLastError(); 
      CTrade trade;
      trade.PositionOpen(my_symbol, my_trade_type, Lot, my_price, 0,0, TradeComment);
      
      return_code = trade.ResultRetcode();             // get the order send result from MqlTradeResult structure
      if (return_code == TRADE_RETCODE_PLACED || return_code == TRADE_RETCODE_DONE || return_code == 0)
         {
         //--- get the ticket
         ticket = trade.ResultOrder();
         deal   = trade.ResultDeal();
         Print("Success sending order for ",my_symbol," (",trade.ResultComment(),") with ticket = ", ticket," and deal = ",deal," after ",try," trying.");

         // modifying position adding tp and sl
         Sleep (5); // <<=== strangely we need this sleep to successfully run modifying 
         ResetLastError(); 
         // CTrade trade;
         trade.PositionModify (my_symbol, my_price + My_SL*SymbolInfoDouble(my_symbol,SYMBOL_POINT), my_price + My_TP*SymbolInfoDouble(my_symbol,SYMBOL_POINT));
         Print("Modifying status = ",trade.ResultComment());
         TradesSent ++;
         break;
         }
         else
         {
         //---get last error
         Print("Fail ",try," to send order ",my_symbol," with return code ",return_code," (",trade.ResultComment(),") and error code ",GetLastError());
         // some error code process here to decide whether to continue open position or not
         }
      
      }
   
   return (ticket);
   }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+